/* -*- buffer-read-only: t -*- vi: set ro:
#line 382
   THIS FILE IS GENERATED AUTOMATICALLY.  PLEASE DO NOT EDIT.
#line 382
*/
#ifdef HAVE_CONFIG_H
# include <config.h>
#endif
#include <sys/types.h>
#include "mailfrom.h"
#include "prog.h"
#include "builtin.h"

#line 17 "bi_db.m4"
/* This file is part of mailfrom filter.             -*- c -*-
#line 17
   Copyright (C) 2006 Sergey Poznyakoff
#line 17

#line 17
   This program is free software; you can redistribute it and/or modify
#line 17
   it under the terms of the GNU General Public License as published by
#line 17
   the Free Software Foundation; either version 2, or (at your option)
#line 17
   any later version.
#line 17

#line 17
   This program is distributed in the hope that it will be useful,
#line 17
   but WITHOUT ANY WARRANTY; without even the implied warranty of
#line 17
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#line 17
   GNU General Public License for more details.
#line 17

#line 17
   You should have received a copy of the GNU General Public License
#line 17
   along with this program; if not, write to the Free Software
#line 17
   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
#line 17
   MA 02110-1301 USA */

#define LOOKUP_NULL_BYTE 0x1
#define LOOKUP_TEST_ONLY 0x2

static int
dbmap_lookup(eval_environ_t env, char *dbname, const char *keystr,
	     const char *defval, int flags)
{
	int rc;
	DBM_FILE db;
	DBM_DATUM key;
	DBM_DATUM contents;

	if (!defval)
		defval = "";
	if (mu_dbm_open(dbname, &db, MU_STREAM_READ, 0, NULL))
			do {
#line 38
		if (env_catch(env, mf_dbfailure) == 0)
#line 38
			return -1;
#line 38
		else
#line 38
			runtime_error(env,
#line 38
				      
#line 38
			              "mu_dbm_open(%s) failed: %s",dbname,mu_dbm_strerror());
#line 38
	} while (0) 
#line 38
;

	memset(&key, 0, sizeof key);
	memset(&contents, 0, sizeof contents);
	MU_DATUM_PTR(key) = (void*) keystr;
	MU_DATUM_SIZE(key) = strlen(keystr);
	if (flags & LOOKUP_NULL_BYTE)
		MU_DATUM_SIZE(key)++;
	rc = mu_dbm_fetch(&db, key, &contents) == 0;
	debug2(10, "Looking up %s: %s", keystr, rc ? "true" : "false");
	if (flags & LOOKUP_TEST_ONLY) 
		push(env, (STKVAL)rc);
	else {
		if (!rc) {
			if (defval)
				pushs(env, (STKVAL)defval);
			else
				push(env, 0);
		} else if (((char*)MU_DATUM_PTR(contents))[MU_DATUM_SIZE(contents)-1]) {
			size_t len = MU_DATUM_SIZE(contents);
			char *s = heap_reserve(env, len + 1);
			memcpy(s, MU_DATUM_PTR(contents), len);
			s[len] = 0;
			push(env, (STKVAL) s);
		} else
			pushs(env, MU_DATUM_PTR(contents));
	}
	mu_dbm_datum_free(&contents);
	mu_dbm_close(&db);
	return rc;
}

void
#line 70
bi_dbmap(eval_environ_t env)
#line 70 "bi_db.m4"
{
#line 70
	
#line 70
char * dbname = (char *) get_arg(env, 2);
#line 70
        char * key = (char *) get_arg(env, 1);
#line 70
        long  null = (long ) get_arg(env, 0);
#line 70
        
#line 70
        adjust_stack(env, 3);
#line 70

#line 70
	if (prog_trace_option & BUILTIN_MASK_db)
#line 70
		prog_trace(env, "dbmap %s %s %lu",dbname, key, null);;
#line 70

{
	dbmap_lookup(env, dbname, key, NULL,
		     LOOKUP_TEST_ONLY | (null ? LOOKUP_NULL_BYTE : 0));
}
}

#line 78
void
#line 78
bi_dbget(eval_environ_t env)
#line 78 "bi_db.m4"
{
#line 78
	
#line 78
char * dbname = (char *) get_arg(env, 3);
#line 78
        char * key = (char *) get_arg(env, 2);
#line 78
        char * defval = (char *) get_arg(env, 1);
#line 78
        long  null = (long ) get_arg(env, 0);
#line 78
        
#line 78
        adjust_stack(env, 4);
#line 78

#line 78
	if (prog_trace_option & BUILTIN_MASK_db)
#line 78
		prog_trace(env, "dbget %s %s %s %lu",dbname, key, defval, null);;
#line 78

{
	dbmap_lookup(env, dbname, key, defval, (null ? LOOKUP_NULL_BYTE : 0));
}
}

#line 85
void
#line 85
bi_dbput(eval_environ_t env)
#line 85 "bi_db.m4"
{
#line 85
	
#line 85
char * dbname = (char *) get_arg(env, 3);
#line 85
        char * keystr = (char *) get_arg(env, 2);
#line 85
        char * value = (char *) get_arg(env, 1);
#line 85
        long  null = (long ) get_arg(env, 0);
#line 85
        
#line 85
        adjust_stack(env, 4);
#line 85

#line 85
	if (prog_trace_option & BUILTIN_MASK_db)
#line 85
		prog_trace(env, "dbput %s %s %s %lu",dbname, keystr, value, null);;
#line 85

{
	int rc;
	DBM_FILE db;
	DBM_DATUM key;
	DBM_DATUM contents;
	
	if (mu_dbm_open(dbname, &db, MU_STREAM_RDWR, 0640, NULL))
			do {
#line 96
		if (env_catch(env, mf_dbfailure) == 0)
#line 96
			return ;
#line 96
		else
#line 96
			runtime_error(env,
#line 96
				                                                  "dbput: " "mu_dbm_open(%s) failed: %s",dbname,mu_dbm_strerror());
#line 96
	} while (0) 
#line 96
;
	memset(&key, 0, sizeof key);
	MU_DATUM_PTR(key) = keystr;
	MU_DATUM_SIZE(key) = strlen(keystr);
	if (null)
		MU_DATUM_SIZE(key)++;

	memset(&contents, 0, sizeof contents);
	MU_DATUM_PTR(contents) = value;
	MU_DATUM_SIZE(contents) = strlen(value) + 1;
	
	rc = mu_dbm_insert(&db, key, contents, 1);
	mu_dbm_close(&db);
		if (!(rc == 0))
#line 115
			do {
#line 115
		if (env_catch(env, mf_dbfailure) == 0)
#line 115
			return ;
#line 115
		else
#line 115
			runtime_error(env,
#line 115
				                                                  "dbput: " "failed to insert data to %s: (%s, %s): %s",dbname,key,value,mu_dbm_strerror());
#line 115
	} while (0) 
#line 115
;
#line 115
;
}
}

void
#line 119
bi_dbdel(eval_environ_t env)
#line 119 "bi_db.m4"
{
#line 119
	
#line 119
char * dbname = (char *) get_arg(env, 2);
#line 119
        char * keystr = (char *) get_arg(env, 1);
#line 119
        long  null = (long ) get_arg(env, 0);
#line 119
        
#line 119
        adjust_stack(env, 3);
#line 119

#line 119
	if (prog_trace_option & BUILTIN_MASK_db)
#line 119
		prog_trace(env, "dbdel %s %s %lu",dbname, keystr, null);;
#line 119

{
	DBM_FILE db;
	DBM_DATUM key;
	
	if (mu_dbm_open(dbname, &db, MU_STREAM_RDWR, 0640, NULL))
			do {
#line 128
		if (env_catch(env, mf_dbfailure) == 0)
#line 128
			return ;
#line 128
		else
#line 128
			runtime_error(env,
#line 128
				                                                  "dbdel: " "mu_dbm_open(%s) failed: %s",dbname,mu_dbm_strerror());
#line 128
	} while (0) 
#line 128
;
	memset(&key, 0, sizeof key);
	MU_DATUM_PTR(key) = keystr;
	MU_DATUM_SIZE(key) = strlen(keystr);
	if (null)
		MU_DATUM_SIZE(key)++;
	mu_dbm_delete(&db, key);
	mu_dbm_close(&db);
}
}


static void
greylist_print_item(const char *key, size_t size, const void *content)
{
	time_t timestamp = *(time_t*) content;
	size--; /* Size includes the trailing nul */
	printf("%*.*s ", size, size, key);
	format_time_str(stdout, timestamp);
	putchar('\n');
}

static int
greylist_expire_item(const void *content)
{
	time_t timestamp = *(time_t*) content;
	return greylist_format->expire_interval &&
		time(NULL) - timestamp > greylist_format->expire_interval;
}


static struct db_format greylist_format_struct = {
	"greylist",
	DEFAULT_GREYLIST_DATABASE,
	DEFAULT_EXPIRE_INTERVAL,
	greylist_print_item,
	greylist_expire_item
};

struct db_format *greylist_format = &greylist_format_struct;

static size_t greylist_seconds_left_loc
#line 169 "bi_db.m4"
;

#line 175
/* greylist(key, interval)
#line 175

#line 175
   Returns true if the key is greylisted, false if it's OK to
#line 175
   deliver mail.
#line 175
 */
void
#line 176
bi_greylist(eval_environ_t env)
#line 176 "bi_db.m4"
{
#line 176
	
#line 176
char * email = (char *) get_arg(env, 1);
#line 176
        long  interval = (long ) get_arg(env, 0);
#line 176
        
#line 176
        adjust_stack(env, 2);
#line 176

#line 176
	if (prog_trace_option & BUILTIN_MASK_db)
#line 176
		prog_trace(env, "greylist %s %lu",email, interval);;
#line 176

{
	int rc;
	DBM_FILE db;
	DBM_DATUM key;
	DBM_DATUM contents;
	int readonly;
	time_t now;

	if (prog_trace_option)
		prog_trace(env, "GREYLIST %s %ld %ld", email, interval);

	rc = mu_dbm_open(greylist_format->dbname, &db, MU_STREAM_RDWR, 0600,
			 &readonly);
        	if (!(rc == 0))
			do {
#line 191
		if (env_catch(env, mf_dbfailure) == 0)
#line 191
			return ;
#line 191
		else
#line 191
			runtime_error(env,
#line 191
				                                                  "greylist: " "mu_dbm_open(%s) failed: %s",greylist_format->dbname,mu_dbm_strerror());
#line 191
	} while (0) 
#line 191
;
#line 191
;
	
	memset(&key, 0, sizeof key);
	memset(&contents, 0, sizeof contents);
	MU_DATUM_PTR(key) = email;
	MU_DATUM_SIZE(key) = strlen(email)+1;

	time(&now);
	if (mu_dbm_fetch(&db, key, &contents) == 0) {
		time_t timestamp, diff;

			if (!(MU_DATUM_SIZE(contents) == sizeof timestamp))
#line 205
			do {
#line 205
		if (env_catch(env, mf_dbfailure) == 0)
#line 205
			return ;
#line 205
		else
#line 205
			runtime_error(env,
#line 205
				                                                  "greylist: " "greylist database %s has wrong data size",greylist_format->dbname);
#line 205
	} while (0) 
#line 205
;
#line 205
;
		
		timestamp = *(time_t*) MU_DATUM_PTR(contents);
		diff = now - timestamp;
	
		__DBG(20) {
			char timebuf[32];
			debug_log("%s entered greylist database on %s, "
				  "%ld seconds ago",
				  email,
				  mailfromd_timestr(timestamp, timebuf,
						    sizeof timebuf),
				  (long) diff);
		}

		if (diff < interval) {
			diff = interval - diff;

			*env_var_ref(env, greylist_seconds_left_loc) = (STKVAL) (diff);
			
			debug2(20, "%s still greylisted (for %lu sec.)",
			       email,
			       (unsigned long) diff);
			rc = 1;
		} else if (diff > greylist_format->expire_interval) {
			debug1(20, "greylist record for %s expired",
			       email);
			if (!readonly) {
				memcpy(MU_DATUM_PTR(contents),
				       &now, sizeof now);
				if (mu_dbm_insert(&db, key, contents, 1))
					mu_error("Cannot insert datum in "
						 "greylist database %s",
						 greylist_format->dbname);
			} else
				debug(20, "database opened in readonly mode: "
				      "not updating");
			rc = 1;
		} else {
			debug1(20, "%s finished greylisting period",
			       email);
			rc = 0;
		}
		mu_dbm_datum_free(&contents);
	} else if (!readonly) {
		debug1(20, "greylisting %s", email);
		*env_var_ref(env, greylist_seconds_left_loc) = (STKVAL) (interval);
		MU_DATUM_PTR(contents) = (void*)&now;
		MU_DATUM_SIZE(contents) = sizeof now;
		if (mu_dbm_insert(&db, key, contents, 1))
			mu_error("Cannot insert datum in greylist "
				 "database %s: %s",
				 greylist_format->dbname,
				 mu_dbm_strerror());
		rc = 1;
	} else
		rc = 0;

	mu_dbm_close(&db);

	do {
#line 265
push(env, (STKVAL) (rc));
#line 265
return;
#line 265
} while (0);
}
}


#line 269
void
#line 269
db_init_builtin()
#line 269
{
#line 269
	#line 70 "bi_db.m4"
va_builtin_install_ex("dbmap", bi_dbmap, 0, 0, dtype_number,  3, 1,  dtype_string, dtype_string, dtype_number);
#line 78 "bi_db.m4"
va_builtin_install_ex("dbget", bi_dbget, 0, 0, dtype_string,  4, 2,  dtype_string, dtype_string, dtype_string, dtype_number);
#line 85 "bi_db.m4"
va_builtin_install_ex("dbput", bi_dbput, 0, 0, dtype_unspecified,  4, 1,  dtype_string, dtype_string, dtype_string, dtype_number);
#line 119 "bi_db.m4"
va_builtin_install_ex("dbdel", bi_dbdel, 0, 0, dtype_unspecified,  3, 1,  dtype_string, dtype_string, dtype_number);
#line 169 "bi_db.m4"
	greylist_seconds_left_loc = builtin_variable_install("greylist_seconds_left", dtype_number, VAR_VOLATILE)->off;
#line 176 "bi_db.m4"
va_builtin_install_ex("greylist", bi_greylist, 0, 0, dtype_number,  2, 0,  dtype_string, dtype_number);

#line 269 "bi_db.m4"
		
#line 269
}

#line 0

#line 0

